=== requirements.txt ===
tbump
wheel
cmake-build-extension
build
twine
setuptools_scm
setuptools-git
deprecation
