=== samples/add_subdirectory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(ryml-quickstart LANGUAGES CXX)

add_subdirectory(../../ ryml)

add_executable(ryml-quickstart ../quickstart.cpp)
target_link_libraries(ryml-quickstart ryml::ryml)

add_custom_target(run ryml-quickstart
    COMMAND $<TARGET_FILE:ryml-quickstart>
    DEPENDS ryml-quickstart
    COMMENT "running: $<TARGET_FILE:ryml-quickstart>")
