=== debian/changelog ===
rapidyaml (0.10.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream metadata.

 -- Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>  Wed, 01 Oct 2025 19:33:30 +0000
