=== debian/control ===
Source: rapidyaml
Section: libs
Priority: optional
Maintainer: Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>
Build-Depends:
    cmake,
    debhelper-compat (= 13),
    libc4core-dev
Standards-Version: 4.7.2
Homepage: https://github.com/biojppm/rapidyaml
Vcs-Browser: https://salsa.debian.org/debian/rapidyaml
Vcs-Git: https://salsa.debian.org/debian/rapidyaml.git

Package: libryml0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ library to parse and emit YAML
 C++ library to parse and emit YAML, and do it fast. ryml parses both read-only
 and in-situ source buffers; the resulting data nodes hold only views to
 sub-ranges of the source buffer.
 .
 This package holds the header and development library link.

Package: libryml-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libryml0 (= ${binary:Version})
Description: C++ library to parse and emit YAML (development files)
 C++ library to parse and emit YAML, and do it fast. ryml parses both read-only
 and in-situ source buffers; the resulting data nodes hold only views to
 sub-ranges of the source buffer.
