=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -DC4CORE_NO_FAST_FLOAT=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	mkdir -p ext/c4core
	touch    ext/c4core/CMakeLists.txt
	ln -r -s ./extcmake ext/c4core/cmake
	dh_auto_configure -- -DRYML_BUILD_API_PYTHON=OFF -DBUILD_SHARED_LIBS=SHARED
